searchNodes=[{"doc":"A native Braintree client library for Elixir. Only a subset of the API is supported and this is a work in progress. That said, it is already used in production, and any modules that have been implemented can be used. For general reference please see: https://developers.braintreepayments.com/reference/overview","ref":"Braintree.html","title":"Braintree","type":"module"},{"doc":"Convenience function for retrieving braintree specfic environment values, but will raise an exception if values are missing. Example iex&gt; Braintree . get_env ( :random_value ) ** (Braintree.ConfigError) missing config for :random_value iex&gt; Braintree . get_env ( :random_value , &quot;random&quot; ) &quot;random&quot; iex&gt; Application . put_env ( :braintree , :random_value , &quot;not-random&quot; ) ...&gt; value = Braintree . get_env ( :random_value ) ...&gt; Application . delete_env ( :braintree , :random_value ) ...&gt; value &quot;not-random&quot; iex&gt; System . put_env ( &quot;RANDOM&quot; , &quot;not-random&quot; ) ...&gt; Application . put_env ( :braintree , :system_value , { :system , &quot;RANDOM&quot; } ) ...&gt; value = Braintree . get_env ( :system_value ) ...&gt; System . delete_env ( &quot;RANDOM&quot; ) ...&gt; value &quot;not-random&quot;","ref":"Braintree.html#get_env/2","title":"Braintree.get_env/2","type":"function"},{"doc":"Convenience function for setting braintree application environment variables. Example iex&gt; Braintree . put_env ( :thingy , &quot;thing&quot; ) ...&gt; Braintree . get_env ( :thingy ) &quot;thing&quot;","ref":"Braintree.html#put_env/2","title":"Braintree.put_env/2","type":"function"},{"doc":"Add-ons and discounts are created in the Control Panel. You cannot create or update them through the API. Add-ons and discounts can be applied manually on a case-by-case basis, or you can associate them with certain plans to apply them automatically to new subscriptions. When creating a subscription, it will automatically inherit any add-ons and/or discounts associated with the plan. You can override those details at the time you create or update the subscription.","ref":"Braintree.AddOn.html","title":"Braintree.AddOn","type":"module"},{"doc":"Returns a list of Braintree::AddOn structs. Example { :ok , addons } = Braintree.AddOns . all ( )","ref":"Braintree.AddOn.html#all/1","title":"Braintree.AddOn.all/1","type":"function"},{"doc":"","ref":"Braintree.AddOn.html#new/1","title":"Braintree.AddOn.new/1","type":"function"},{"doc":"","ref":"Braintree.AddOn.html#t:t/0","title":"Braintree.AddOn.t/0","type":"type"},{"doc":"You can create an address for a customer only although the structure is also used for a merchant account. For additional reference see: https://developers.braintreepayments.com/reference/request/address/create/ruby","ref":"Braintree.Address.html","title":"Braintree.Address","type":"module"},{"doc":"Create an address record, or return an error response after failed validation. Example = Braintree.Address.create(&quot;customer_id&quot;, %{ first_name : &quot;Jenna&quot; }) address.company # Braintree","ref":"Braintree.Address.html#create/3","title":"Braintree.Address.create/3","type":"function"},{"doc":"You can delete an address using its customer ID and address ID. Example :ok = Braintree.Address . delete ( &quot;customer_id&quot; , &quot;address_id&quot; )","ref":"Braintree.Address.html#delete/3","title":"Braintree.Address.delete/3","type":"function"},{"doc":"If you want to look up a single address for a customer using the customer ID and the address ID, use the find method. Example address = Braintree.Address.find(&quot;customer_id&quot;, &quot;address_id&quot;)","ref":"Braintree.Address.html#find/3","title":"Braintree.Address.find/3","type":"function"},{"doc":"Convert a map into a Address struct. Example address = Braintree.Address . new ( %{ &quot;company&quot; =&gt; &quot;Braintree&quot; } )","ref":"Braintree.Address.html#new/1","title":"Braintree.Address.new/1","type":"function"},{"doc":"To update an address, use a customer's ID with an address's ID along with new attributes. The same validations apply as when creating an address. Any attribute not passed will remain unchanged. Example { :ok , address } = Braintree.Address . update ( &quot;customer_id&quot; , &quot;address_id&quot; , %{ company : &quot;New Company Name&quot; } ) address . company # &quot;New Company Name&quot;","ref":"Braintree.Address.html#update/4","title":"Braintree.Address.update/4","type":"function"},{"doc":"","ref":"Braintree.Address.html#t:t/0","title":"Braintree.Address.t/0","type":"type"},{"doc":"AndroidPayCard structs are not created directly, but are built within responses from other endpoints, such as Braintree.Customer . For additional reference see: https://developers.braintreepayments.com/reference/response/android-pay-card/ruby","ref":"Braintree.AndroidPayCard.html","title":"Braintree.AndroidPayCard","type":"module"},{"doc":"","ref":"Braintree.AndroidPayCard.html#new/1","title":"Braintree.AndroidPayCard.new/1","type":"function"},{"doc":"","ref":"Braintree.AndroidPayCard.html#t:t/0","title":"Braintree.AndroidPayCard.t/0","type":"type"},{"doc":"ApplePayCard structs are not created directly, but are built within responsees from other endpoints, such as Braintree.Customer .","ref":"Braintree.ApplePayCard.html","title":"Braintree.ApplePayCard","type":"module"},{"doc":"","ref":"Braintree.ApplePayCard.html#new/1","title":"Braintree.ApplePayCard.new/1","type":"function"},{"doc":"","ref":"Braintree.ApplePayCard.html#t:t/0","title":"Braintree.ApplePayCard.t/0","type":"type"},{"doc":"Generate a token required by the client SDK to communicate with Braintree. For additional reference see: https://developers.braintreepayments.com/reference/request/client-token/generate/ruby","ref":"Braintree.ClientToken.html","title":"Braintree.ClientToken","type":"module"},{"doc":"Create a client token, or return an error response. Options :version - The default value is 2. Current supported versions are 1, 2, and 3. Please check your client-side SDKs in use before changing this value. Example { :ok , token } = Braintree.ClientToken . generate ( ) Generate a specific token version: { :ok , token } = Braintree.ClientToken . generate ( %{ version : 3 } )","ref":"Braintree.ClientToken.html#generate/2","title":"Braintree.ClientToken.generate/2","type":"function"},{"doc":"This module provides a use macro to help convert raw HTTP responses into structs.","ref":"Braintree.Construction.html","title":"Braintree.Construction","type":"module"},{"doc":"Convert a response into one or more typed structs.","ref":"Braintree.Construction.html#new/2","title":"Braintree.Construction.new/2","type":"function"},{"doc":"CreditCard structs are not created directly, but are built within responsees from other endpoints, such as Braintree.Customer .","ref":"Braintree.CreditCard.html","title":"Braintree.CreditCard","type":"module"},{"doc":"","ref":"Braintree.CreditCard.html#new/1","title":"Braintree.CreditCard.new/1","type":"function"},{"doc":"","ref":"Braintree.CreditCard.html#t:t/0","title":"Braintree.CreditCard.t/0","type":"type"},{"doc":"Manage credit card verifications. For additional reference see: https://developers.braintreepayments.com/reference/response/credit-card-verification/ruby","ref":"Braintree.CreditCardVerification.html","title":"Braintree.CreditCardVerification","type":"module"},{"doc":"Convert a map into a CreditCardVerification struct. Example verification = Braintree.CreditCardVerification . new ( %{ &quot;credit_card_card_type&quot; =&gt; &quot;Visa&quot; } )","ref":"Braintree.CreditCardVerification.html#new/1","title":"Braintree.CreditCardVerification.new/1","type":"function"},{"doc":"To search for credit card verifications, pass a map of search parameters. Example: search_params = %{amount: %{min: &quot;10.0&quot;, max: &quot;15.0&quot;}, status : [ &quot;approved&quot; , &quot;pending&quot; ] } = Braintree.CreditCardVerification.search(search_params)","ref":"Braintree.CreditCardVerification.html#search/2","title":"Braintree.CreditCardVerification.search/2","type":"function"},{"doc":"","ref":"Braintree.CreditCardVerification.html#t:t/0","title":"Braintree.CreditCardVerification.t/0","type":"type"},{"doc":"You can create a customer by itself, with a payment method, or with a credit card with a billing address. For additional reference see: https://developers.braintreepayments.com/reference/request/customer/create/ruby","ref":"Braintree.Customer.html","title":"Braintree.Customer","type":"module"},{"doc":"Create a customer record, or return an error response with after failed validation. Example { :ok , customer } = Braintree.Customer . create ( %{ first_name : &quot;Jen&quot; , last_name : &quot;Smith&quot; , company : &quot;Braintree&quot; , email : &quot;jen@example.com&quot; , phone : &quot;312.555.1234&quot; , fax : &quot;614.555.5678&quot; , website : &quot;www.example.com&quot; } ) customer . company # Braintree","ref":"Braintree.Customer.html#create/2","title":"Braintree.Customer.create/2","type":"function"},{"doc":"You can delete a customer using its ID. When a customer is deleted, all associated payment methods are also deleted, and all associated recurring billing subscriptions are canceled. Example :ok = Braintree.Customer . delete ( &quot;customer_id&quot; )","ref":"Braintree.Customer.html#delete/2","title":"Braintree.Customer.delete/2","type":"function"},{"doc":"If you want to look up a single customer using its ID, use the find method. Example customer = Braintree.Customer . find ( &quot;customer_id&quot; )","ref":"Braintree.Customer.html#find/2","title":"Braintree.Customer.find/2","type":"function"},{"doc":"Convert a map into a Company struct along with nested payment options. Credit cards and paypal accounts are converted to a list of structs as well. Example customer = Braintree.Customer . new ( %{ &quot;company&quot; =&gt; &quot;Soren&quot; , &quot;email&quot; =&gt; &quot;parker@example.com&quot; } )","ref":"Braintree.Customer.html#new/1","title":"Braintree.Customer.new/1","type":"function"},{"doc":"To search for customers, pass a map of search parameters. Example: { :ok , customers } = Braintree.Customer . search ( %{ first_name : %{ is : &quot;Jenna&quot; } } )","ref":"Braintree.Customer.html#search/2","title":"Braintree.Customer.search/2","type":"function"},{"doc":"To update a customer, use its ID along with new attributes. The same validations apply as when creating a customer. Any attribute not passed will remain unchanged. Example { :ok , customer } = Braintree.Customer . update ( &quot;customer_id&quot; , %{ company : &quot;New Company Name&quot; } ) customer . company # &quot;New Company Name&quot;","ref":"Braintree.Customer.html#update/3","title":"Braintree.Customer.update/3","type":"function"},{"doc":"","ref":"Braintree.Customer.html#t:t/0","title":"Braintree.Customer.t/0","type":"type"},{"doc":"Add-ons and discounts are created in the Control Panel. You cannot create or update them through the API. Add-ons and discounts can be applied manually on a case-by-case basis, or you can associate them with certain plans to apply them automatically to new subscriptions. When creating a subscription, it will automatically inherit any add-ons and/or discounts associated with the plan. You can override those details at the time you create or update the subscription.","ref":"Braintree.Discount.html","title":"Braintree.Discount","type":"module"},{"doc":"Returns a collection of Braintree::Discount objects. Example { :ok , discounts } = Braintree.Discount . all ( )","ref":"Braintree.Discount.html#all/1","title":"Braintree.Discount.all/1","type":"function"},{"doc":"","ref":"Braintree.Discount.html#new/1","title":"Braintree.Discount.new/1","type":"function"},{"doc":"","ref":"Braintree.Discount.html#t:t/0","title":"Braintree.Discount.t/0","type":"type"},{"doc":"A general purpose response wrapper that is built for any failed API response. See the following pages for details about the various processor responses: https://developers.braintreepayments.com/reference/general/processor-responses/authorization-responses https://developers.braintreepayments.com/reference/general/processor-responses/settlement-responses https://developers.braintreepayments.com/reference/general/processor-responses/avs-cvv-responses","ref":"Braintree.ErrorResponse.html","title":"Braintree.ErrorResponse","type":"module"},{"doc":"","ref":"Braintree.ErrorResponse.html#new/1","title":"Braintree.ErrorResponse.new/1","type":"function"},{"doc":"","ref":"Braintree.ErrorResponse.html#t:t/0","title":"Braintree.ErrorResponse.t/0","type":"type"},{"doc":"Base client for all server interaction, used by all endpoint specific modules. This request wrapper coordinates the remote server, headers, authorization and SSL options. Using Braintree.HTTP requires the presence of three config values: merchant_id - Braintree merchant id private_key - Braintree private key public_key - Braintree public key All three values must be set or a Braintree.ConfigError will be raised at runtime. All those config values support the {:system, &quot;VAR_NAME&quot;} as a value - in which case the value will be read from the system environment with System.get_env(&quot;VAR_NAME&quot;) .","ref":"Braintree.HTTP.html","title":"Braintree.HTTP","type":"module"},{"doc":"","ref":"Braintree.HTTP.html#delete/1","title":"Braintree.HTTP.delete/1","type":"function"},{"doc":"","ref":"Braintree.HTTP.html#delete/2","title":"Braintree.HTTP.delete/2","type":"function"},{"doc":"","ref":"Braintree.HTTP.html#delete/3","title":"Braintree.HTTP.delete/3","type":"function"},{"doc":"","ref":"Braintree.HTTP.html#get/1","title":"Braintree.HTTP.get/1","type":"function"},{"doc":"","ref":"Braintree.HTTP.html#get/2","title":"Braintree.HTTP.get/2","type":"function"},{"doc":"","ref":"Braintree.HTTP.html#get/3","title":"Braintree.HTTP.get/3","type":"function"},{"doc":"","ref":"Braintree.HTTP.html#post/1","title":"Braintree.HTTP.post/1","type":"function"},{"doc":"","ref":"Braintree.HTTP.html#post/2","title":"Braintree.HTTP.post/2","type":"function"},{"doc":"","ref":"Braintree.HTTP.html#post/3","title":"Braintree.HTTP.post/3","type":"function"},{"doc":"","ref":"Braintree.HTTP.html#put/1","title":"Braintree.HTTP.put/1","type":"function"},{"doc":"","ref":"Braintree.HTTP.html#put/2","title":"Braintree.HTTP.put/2","type":"function"},{"doc":"","ref":"Braintree.HTTP.html#put/3","title":"Braintree.HTTP.put/3","type":"function"},{"doc":"Centralized request handling function. All convenience structs use this function to interact with the Braintree servers. This function can be used directly to supplement missing functionality. Example defmodule MyApp.Disbursement do alias Braintree.HTTP def disburse ( params \\ %{ } ) do HTTP . request ( :get , &quot;disbursements&quot; , params ) end end","ref":"Braintree.HTTP.html#request/4","title":"Braintree.HTTP.request/4","type":"function"},{"doc":"","ref":"Braintree.HTTP.html#t:response/0","title":"Braintree.HTTP.response/0","type":"type"},{"doc":"Represents a merchant account in a marketplace. For additional reference, see: https://developers.braintreepayments.com/reference/response/merchant-account/ruby","ref":"Braintree.Merchant.Account.html","title":"Braintree.Merchant.Account","type":"module"},{"doc":"Create a merchant account or return an error response after failed validation Example = Braintree.Merchant.Account.create(%{ tos_accepted : true , })","ref":"Braintree.Merchant.Account.html#create/2","title":"Braintree.Merchant.Account.create/2","type":"function"},{"doc":"If you want to look up a single merchant using ID, use the find method. Example merchant = Braintree.Merchant.find(&quot;merchant_id&quot;)","ref":"Braintree.Merchant.Account.html#find/2","title":"Braintree.Merchant.Account.find/2","type":"function"},{"doc":"Convert a map into a Braintree.Merchant.Account struct.","ref":"Braintree.Merchant.Account.html#new/1","title":"Braintree.Merchant.Account.new/1","type":"function"},{"doc":"To update a merchant, use its ID along with new attributes. The same validations apply as when creating a merchant. Any attribute not passed will remain unchanged. Example { :ok , merchant } = Braintree.Merchant . update ( &quot;merchant_id&quot; , %{ funding_details : %{ account_number : &quot;1234567890&quot; } } ) merchant . funding_details . account_number # &quot;1234567890&quot;","ref":"Braintree.Merchant.Account.html#update/3","title":"Braintree.Merchant.Account.update/3","type":"function"},{"doc":"","ref":"Braintree.Merchant.Account.html#t:t/0","title":"Braintree.Merchant.Account.t/0","type":"type"},{"doc":"Represents the business section of a merchant account. For additional reference, see: https://developers.braintreepayments.com/reference/response/merchant-account/ruby","ref":"Braintree.Merchant.Business.html","title":"Braintree.Merchant.Business","type":"module"},{"doc":"","ref":"Braintree.Merchant.Business.html#new/1","title":"Braintree.Merchant.Business.new/1","type":"function"},{"doc":"","ref":"Braintree.Merchant.Business.html#t:t/0","title":"Braintree.Merchant.Business.t/0","type":"type"},{"doc":"Represents the funding section of a merchant account. For additional reference, see: https://developers.braintreepayments.com/reference/response/merchant-account/ruby","ref":"Braintree.Merchant.Funding.html","title":"Braintree.Merchant.Funding","type":"module"},{"doc":"","ref":"Braintree.Merchant.Funding.html#new/1","title":"Braintree.Merchant.Funding.new/1","type":"function"},{"doc":"","ref":"Braintree.Merchant.Funding.html#t:t/0","title":"Braintree.Merchant.Funding.t/0","type":"type"},{"doc":"Represents the individual section of a merchant account. For additional reference, see: https://developers.braintreepayments.com/reference/response/merchant-account/ruby","ref":"Braintree.Merchant.Individual.html","title":"Braintree.Merchant.Individual","type":"module"},{"doc":"","ref":"Braintree.Merchant.Individual.html#new/1","title":"Braintree.Merchant.Individual.new/1","type":"function"},{"doc":"","ref":"Braintree.Merchant.Individual.html#t:t/0","title":"Braintree.Merchant.Individual.t/0","type":"type"},{"doc":"Create, update, find and delete payment methods. Payment methods may be a CreditCard or a PaypalAccount .","ref":"Braintree.PaymentMethod.html","title":"Braintree.PaymentMethod","type":"module"},{"doc":"Create a payment method record, or return an error response with after failed validation. Example { :ok , customer } = Braintree.Customer . create ( %{ first_name : &quot;Jen&quot; , last_name : &quot;Smith&quot; } ) { :ok , credit_card } = Braintree.PaymentMethod . create ( %{ customer_id : customer . id , payment_method_nonce : Braintree.Testing.Nonces . transactable } ) credit_card . type # &quot;Visa&quot;","ref":"Braintree.PaymentMethod.html#create/2","title":"Braintree.PaymentMethod.create/2","type":"function"},{"doc":"Delete a payment method record, or return an error response if token invalid Example { :ok , &quot;Success&quot; } = Braintree.PaymentMethod . delete ( token )","ref":"Braintree.PaymentMethod.html#delete/2","title":"Braintree.PaymentMethod.delete/2","type":"function"},{"doc":"Find a payment method record, or return an error response if token invalid Example { :ok , payment_method } = Braintree.PaymentMethod . find ( token ) payment_method . type # CreditCard","ref":"Braintree.PaymentMethod.html#find/2","title":"Braintree.PaymentMethod.find/2","type":"function"},{"doc":"Update a payment method record, or return an error response with after failed validation. Example { :ok , customer } = Braintree.Customer . create ( %{ first_name : &quot;Jen&quot; , last_name : &quot;Smith&quot; } ) { :ok , credit_card } = Braintree.PaymentMethod . create ( %{ customer_id : customer . id , cardholder_name : &quot;CH Name&quot; , payment_method_nonce : Braintree.Testing.Nonces . transactable } ) { :ok , payment_method } = Braintree.PaymentMethod . update ( credit_card . token , %{ cardholder_name : &quot;NEW&quot; } ) payment_method . cardholder_name # &quot;NEW&quot;","ref":"Braintree.PaymentMethod.html#update/3","title":"Braintree.PaymentMethod.update/3","type":"function"},{"doc":"Create a payment method nonce from an existing payment method token","ref":"Braintree.PaymentMethodNonce.html","title":"Braintree.PaymentMethodNonce","type":"module"},{"doc":"Create a payment method nonce from token Example { :ok , payment_method_nonce } = Braintree.PaymentMethodNonce . create ( token ) payment_method_nonce . nonce","ref":"Braintree.PaymentMethodNonce.html#create/2","title":"Braintree.PaymentMethodNonce.create/2","type":"function"},{"doc":"Find a payment method nonce, or return an error response if token invalid Example { :ok , payment_method } = Braintree.PaymentMethodNonce . find ( token ) payment_method . type #CreditCard","ref":"Braintree.PaymentMethodNonce.html#find/2","title":"Braintree.PaymentMethodNonce.find/2","type":"function"},{"doc":"","ref":"Braintree.PaymentMethodNonce.html#t:t/0","title":"Braintree.PaymentMethodNonce.t/0","type":"type"},{"doc":"Find, update and delete Paypal Accounts using PaymentMethod token","ref":"Braintree.PaypalAccount.html","title":"Braintree.PaypalAccount","type":"module"},{"doc":"Delete a paypal account record using token or return an error response if the token is invalid. Example { :ok , paypal_account } = Braintree.PaypalAccount . delete ( token )","ref":"Braintree.PaypalAccount.html#delete/2","title":"Braintree.PaypalAccount.delete/2","type":"function"},{"doc":"Find a paypal account record using token or return an error response if the token is invalid. Example { :ok , paypal_account } = Braintree.PaypalAccount . find ( token )","ref":"Braintree.PaypalAccount.html#find/2","title":"Braintree.PaypalAccount.find/2","type":"function"},{"doc":"","ref":"Braintree.PaypalAccount.html#new/1","title":"Braintree.PaypalAccount.new/1","type":"function"},{"doc":"Update a paypal account record using token or return an error response if the token is invalid. Example { :ok , paypal_account } = Braintree.PaypalAccount . update ( token , % { options : %{ make_default : true } )","ref":"Braintree.PaypalAccount.html#update/3","title":"Braintree.PaypalAccount.update/3","type":"function"},{"doc":"","ref":"Braintree.PaypalAccount.html#t:t/0","title":"Braintree.PaypalAccount.t/0","type":"type"},{"doc":"Plans represent recurring billing plans in a Braintree merchant account. The API for plans is read only. For additional reference see: https://developers.braintreepayments.com/reference/request/plan/all/ruby","ref":"Braintree.Plan.html","title":"Braintree.Plan","type":"module"},{"doc":"Get a list of all the plans defined in the merchant account. If there are no plans an empty list is returned. Example { :ok , plans } = Braintree.Plan . all ( )","ref":"Braintree.Plan.html#all/1","title":"Braintree.Plan.all/1","type":"function"},{"doc":"Create a new plan under a merchant account. Example { :ok , plan } = Braintree.Plan . create ( %{ name : &quot;a plan&quot; , billing_frequency : 3 , currency_iso_code : &quot;USD&quot; , price : &quot;10.00&quot; } )","ref":"Braintree.Plan.html#create/2","title":"Braintree.Plan.create/2","type":"function"},{"doc":"Delete a plan defined in the merchant account by the plan id. A plan can't be deleted if it has any former or current subscriptions associated with it. If there is no plan with the specified id, {:error, :not_found} is returned.","ref":"Braintree.Plan.html#delete/2","title":"Braintree.Plan.delete/2","type":"function"},{"doc":"Get a specific plan defined in the merchant account by the plan id. If there is no plan with the specified id, {:error, :not_found} is returned. Example { :ok , plan } = Braintree.Plan . find ( &quot;existing plan_id&quot; ) { :error , :not_found } = Braintree.Plan . find ( &quot;non-existing plan_id&quot; )","ref":"Braintree.Plan.html#find/2","title":"Braintree.Plan.find/2","type":"function"},{"doc":"","ref":"Braintree.Plan.html#new/1","title":"Braintree.Plan.new/1","type":"function"},{"doc":"Updates a specific plan defined in the merchant account by the plan id. If there is no plan with the specified id, {:error, :not_found} is returned. Example { :ok , updated_plan } = Braintree.Plan . find ( &quot;existing plan_id&quot; , %{ name : &quot;new_name&quot; } ) { :error , :not_found } = Braintree.Plan . find ( &quot;non-existing plan_id&quot; )","ref":"Braintree.Plan.html#update/3","title":"Braintree.Plan.update/3","type":"function"},{"doc":"","ref":"Braintree.Plan.html#t:t/0","title":"Braintree.Plan.t/0","type":"type"},{"doc":"This module performs advanced search on a resource. For additional reference see: https://developers.braintreepayments.com/reference/general/searching/search-fields/ruby","ref":"Braintree.Search.html","title":"Braintree.Search","type":"module"},{"doc":"Perform an advanced search on a given resource and create new structs based on the initializer given. Example search_params = %{first_name: %{is: &quot;Jenna&quot;}} {:ok, customers} = Braintree.Search.perform(search_params, &quot;customers&quot;, &amp;Braintree.Customer.new/1)","ref":"Braintree.Search.html#perform/4","title":"Braintree.Search.perform/4","type":"function"},{"doc":"The settlement batch summary displays the total sales and credits for each batch for a particular date. The transactions can be grouped by a single custom field's values. https://developers.braintreepayments.com/reference/request/settlement-batch-summary/generate/ruby","ref":"Braintree.SettlementBatchSummary.html","title":"Braintree.SettlementBatchSummary","type":"module"},{"doc":"Generate a report of all settlements for a particular date. The field used for custom grouping will always be set as custom_field , regardless of its name. Example Braintree.SettlementBatchSummary ( &quot;2016-9-5&quot; , &quot;custom_field_1&quot; )","ref":"Braintree.SettlementBatchSummary.html#generate/3","title":"Braintree.SettlementBatchSummary.generate/3","type":"function"},{"doc":"Convert a map including records into a summary struct with a list of record structs.","ref":"Braintree.SettlementBatchSummary.html#new/1","title":"Braintree.SettlementBatchSummary.new/1","type":"function"},{"doc":"","ref":"Braintree.SettlementBatchSummary.html#t:t/0","title":"Braintree.SettlementBatchSummary.t/0","type":"type"},{"doc":"A record contains details for a transaction in a summary.","ref":"Braintree.SettlementBatchSummary.Record.html","title":"Braintree.SettlementBatchSummary.Record","type":"module"},{"doc":"Convert a list of records into structs, including any custom fields that were used as the grouping value.","ref":"Braintree.SettlementBatchSummary.Record.html#new/1","title":"Braintree.SettlementBatchSummary.Record.new/1","type":"function"},{"doc":"","ref":"Braintree.SettlementBatchSummary.Record.html#t:t/0","title":"Braintree.SettlementBatchSummary.Record.t/0","type":"type"},{"doc":"Manage customer subscriptions to recurring billing plans. For additional reference see: https://developers.braintreepayments.com/reference/request/subscription/create/ruby","ref":"Braintree.Subscription.html","title":"Braintree.Subscription","type":"module"},{"doc":"Cancel an existing subscription by subscription_id . A cancelled subscription cannot be reactivated, you would need to create a new one. Example { :ok , subscription } = Subscription . cancel ( &quot;123&quot; )","ref":"Braintree.Subscription.html#cancel/2","title":"Braintree.Subscription.cancel/2","type":"function"},{"doc":"Create a subscription, or return an error response with after failed validation. Example { :ok , sub } = Braintree.Subscription . create ( %{ payment_method_token : card . token , plan_id : &quot;starter&quot; } )","ref":"Braintree.Subscription.html#create/2","title":"Braintree.Subscription.create/2","type":"function"},{"doc":"Find an existing subscription by subscription_id Example { :ok , subscription } = Subscription . find ( &quot;123&quot; )","ref":"Braintree.Subscription.html#find/2","title":"Braintree.Subscription.find/2","type":"function"},{"doc":"Convert a map into a Subscription struct. Add_ons and transactions are converted to a list of structs as well. Example subscripton = Braintree.Subscription . new ( %{ &quot;plan_id&quot; =&gt; &quot;business&quot; , &quot;status&quot; =&gt; &quot;Active&quot; } )","ref":"Braintree.Subscription.html#new/1","title":"Braintree.Subscription.new/1","type":"function"},{"doc":"You can manually retry charging past due subscriptions. By default, we will use the subscription balance when retrying the transaction. If you would like to use a different amount you can optionally specify the amount for the transaction. A successful manual retry of a past due subscription will always reduce the balance of that subscription to $0, regardless of the amount of the retry. Example { :ok , transaction } = Braintree.Subscription . retry_charge ( sub_id ) { :ok , transaction } = Braintree.Subscription . retry_charge ( sub_id , &quot;24.00&quot; )","ref":"Braintree.Subscription.html#retry_charge/3","title":"Braintree.Subscription.retry_charge/3","type":"function"},{"doc":"To search for subscriptions, pass a map of search parameters. Example: = Braintree.Subscription.search(%{plan_id: %{is: &quot;starter&quot;}})","ref":"Braintree.Subscription.html#search/2","title":"Braintree.Subscription.search/2","type":"function"},{"doc":"To update a subscription, use its ID along with new attributes. The same validations apply as when creating a subscription. Any attribute not passed will remain unchanged. Example { :ok , subscription } = Braintree.Subscription . update ( &quot;subscription_id&quot; , %{ plan_id : &quot;new_plan_id&quot; } ) subscription . plan_id # &quot;new_plan_id&quot;","ref":"Braintree.Subscription.html#update/3","title":"Braintree.Subscription.update/3","type":"function"},{"doc":"","ref":"Braintree.Subscription.html#t:t/0","title":"Braintree.Subscription.t/0","type":"type"},{"doc":"The functions contained in this module provide credit card numbers that should be used when working in the sandbox environment. The sandbox will not accept any credit card numbers other than the ones listed below. See http://www.braintreepayments.com/docs/ruby/reference/sandbox","ref":"Braintree.Testing.CreditCardNumbers.html","title":"Braintree.Testing.CreditCardNumbers","type":"module"},{"doc":"","ref":"Braintree.Testing.CreditCardNumbers.html#all/0","title":"Braintree.Testing.CreditCardNumbers.all/0","type":"function"},{"doc":"","ref":"Braintree.Testing.CreditCardNumbers.html#am_exes/0","title":"Braintree.Testing.CreditCardNumbers.am_exes/0","type":"function"},{"doc":"","ref":"Braintree.Testing.CreditCardNumbers.html#carte_blanches/0","title":"Braintree.Testing.CreditCardNumbers.carte_blanches/0","type":"function"},{"doc":"","ref":"Braintree.Testing.CreditCardNumbers.html#diners_clubs/0","title":"Braintree.Testing.CreditCardNumbers.diners_clubs/0","type":"function"},{"doc":"","ref":"Braintree.Testing.CreditCardNumbers.html#discovers/0","title":"Braintree.Testing.CreditCardNumbers.discovers/0","type":"function"},{"doc":"","ref":"Braintree.Testing.CreditCardNumbers.html#jcbs/0","title":"Braintree.Testing.CreditCardNumbers.jcbs/0","type":"function"},{"doc":"","ref":"Braintree.Testing.CreditCardNumbers.html#master_cards/0","title":"Braintree.Testing.CreditCardNumbers.master_cards/0","type":"function"},{"doc":"","ref":"Braintree.Testing.CreditCardNumbers.html#unknowns/0","title":"Braintree.Testing.CreditCardNumbers.unknowns/0","type":"function"},{"doc":"","ref":"Braintree.Testing.CreditCardNumbers.html#visas/0","title":"Braintree.Testing.CreditCardNumbers.visas/0","type":"function"},{"doc":"These are vendor specific numbers that will always fail verification.","ref":"Braintree.Testing.CreditCardNumbers.FailsSandboxVerification.html","title":"Braintree.Testing.CreditCardNumbers.FailsSandboxVerification","type":"module"},{"doc":"","ref":"Braintree.Testing.CreditCardNumbers.FailsSandboxVerification.html#all/0","title":"Braintree.Testing.CreditCardNumbers.FailsSandboxVerification.all/0","type":"function"},{"doc":"","ref":"Braintree.Testing.CreditCardNumbers.FailsSandboxVerification.html#am_ex/0","title":"Braintree.Testing.CreditCardNumbers.FailsSandboxVerification.am_ex/0","type":"function"},{"doc":"","ref":"Braintree.Testing.CreditCardNumbers.FailsSandboxVerification.html#discover/0","title":"Braintree.Testing.CreditCardNumbers.FailsSandboxVerification.discover/0","type":"function"},{"doc":"","ref":"Braintree.Testing.CreditCardNumbers.FailsSandboxVerification.html#master_card/0","title":"Braintree.Testing.CreditCardNumbers.FailsSandboxVerification.master_card/0","type":"function"},{"doc":"","ref":"Braintree.Testing.CreditCardNumbers.FailsSandboxVerification.html#visa/0","title":"Braintree.Testing.CreditCardNumbers.FailsSandboxVerification.visa/0","type":"function"},{"doc":"A collection of static payment nonces provided to simplify testing server side code. Nonces are preferred over credit card numbers when testing payment methods. Only a subset of nonces are defined here, for the full list see the sandbox documentation about payment method nonces .","ref":"Braintree.Testing.Nonces.html","title":"Braintree.Testing.Nonces","type":"module"},{"doc":"","ref":"Braintree.Testing.Nonces.html#abstract_transactable/0","title":"Braintree.Testing.Nonces.abstract_transactable/0","type":"function"},{"doc":"","ref":"Braintree.Testing.Nonces.html#android_pay_amex_nonce/0","title":"Braintree.Testing.Nonces.android_pay_amex_nonce/0","type":"function"},{"doc":"","ref":"Braintree.Testing.Nonces.html#android_pay_discover_nonce/0","title":"Braintree.Testing.Nonces.android_pay_discover_nonce/0","type":"function"},{"doc":"","ref":"Braintree.Testing.Nonces.html#android_pay_mastercard_nonce/0","title":"Braintree.Testing.Nonces.android_pay_mastercard_nonce/0","type":"function"},{"doc":"","ref":"Braintree.Testing.Nonces.html#android_pay_visa_nonce/0","title":"Braintree.Testing.Nonces.android_pay_visa_nonce/0","type":"function"},{"doc":"","ref":"Braintree.Testing.Nonces.html#apple_pay_am_ex/0","title":"Braintree.Testing.Nonces.apple_pay_am_ex/0","type":"function"},{"doc":"","ref":"Braintree.Testing.Nonces.html#apple_pay_master_card/0","title":"Braintree.Testing.Nonces.apple_pay_master_card/0","type":"function"},{"doc":"","ref":"Braintree.Testing.Nonces.html#apple_pay_visa/0","title":"Braintree.Testing.Nonces.apple_pay_visa/0","type":"function"},{"doc":"","ref":"Braintree.Testing.Nonces.html#coinbase/0","title":"Braintree.Testing.Nonces.coinbase/0","type":"function"},{"doc":"","ref":"Braintree.Testing.Nonces.html#consumed/0","title":"Braintree.Testing.Nonces.consumed/0","type":"function"},{"doc":"","ref":"Braintree.Testing.Nonces.html#paypal_future_payment/0","title":"Braintree.Testing.Nonces.paypal_future_payment/0","type":"function"},{"doc":"","ref":"Braintree.Testing.Nonces.html#transactable/0","title":"Braintree.Testing.Nonces.transactable/0","type":"function"},{"doc":"Create transactions for testing purposes only. Transition to settled, settlement_confirmed, or settlement_declined states.","ref":"Braintree.Testing.TestTransaction.html","title":"Braintree.Testing.TestTransaction","type":"module"},{"doc":"Use a transaction_id to transition to settled status. This allows for testing of refunds. Example = TestTransaction.settle(transaction_id: &quot;123&quot;) transaction.status # &quot;settled&quot;","ref":"Braintree.Testing.TestTransaction.html#settle/1","title":"Braintree.Testing.TestTransaction.settle/1","type":"function"},{"doc":"Use a transaction_id to transition to settled_confirmed status Example = TestTransaction.settlement_confirm( transaction_id: &quot;123&quot;) transaction.status # &quot;settlement_confirmed&quot;","ref":"Braintree.Testing.TestTransaction.html#settlement_confirm/1","title":"Braintree.Testing.TestTransaction.settlement_confirm/1","type":"function"},{"doc":"Use a transaction_id to transition to settlement_declined status Example = TestTransaction.settlement_decline( transaction_id: &quot;123&quot;) transaction.status # &quot;settlement_declined&quot;","ref":"Braintree.Testing.TestTransaction.html#settlement_decline/1","title":"Braintree.Testing.TestTransaction.settlement_decline/1","type":"function"},{"doc":"Create a new sale. To create a transaction, you must include an amount and either a payment_method_nonce or a payment_method_token. https://developers.braintreepayments.com/reference/response/transaction/ruby","ref":"Braintree.Transaction.html","title":"Braintree.Transaction","type":"module"},{"doc":"Find an existing transaction by transaction_id Example { :ok , transaction } = Transaction . find ( &quot;123&quot; )","ref":"Braintree.Transaction.html#find/2","title":"Braintree.Transaction.find/2","type":"function"},{"doc":"Convert a map into a Transaction struct. Add_ons are converted to a list of structs as well. Example transaction = Braintree.Transaction.new(%{ &quot;subscription_id&quot; =&gt; &quot;subxid&quot; , &quot;status&quot; =&gt; &quot;submitted_for_settlement&quot; })","ref":"Braintree.Transaction.html#new/1","title":"Braintree.Transaction.new/1","type":"function"},{"doc":"Use a transaction_id and optional amount to issue a refund for that transaction Example { :ok , transaction } = Transaction . refund ( &quot;123&quot; , %{ amount : &quot;100.00&quot; } ) transaction . status # &quot;refunded&quot;","ref":"Braintree.Transaction.html#refund/3","title":"Braintree.Transaction.refund/3","type":"function"},{"doc":"Use a payment_method_nonce or payment_method_token to make a one time charge against a payment method. Example { :ok , transaction } = Transaction . sale ( %{ amount : &quot;100.00&quot; , payment_method_nonce : @payment_method_nonce , options : %{ submit_for_settlement : true } } ) transaction . status # &quot;settling&quot;","ref":"Braintree.Transaction.html#sale/2","title":"Braintree.Transaction.sale/2","type":"function"},{"doc":"Use a transaction_id and optional amount to settle the transaction. Use this if submit_for_settlement was false while creating the charge using sale. Example { :ok , transaction } = Transaction . submit_for_settlement ( &quot;123&quot; , %{ amount : &quot;100&quot; } ) transaction . status # &quot;settling&quot;","ref":"Braintree.Transaction.html#submit_for_settlement/3","title":"Braintree.Transaction.submit_for_settlement/3","type":"function"},{"doc":"Use a transaction_id to issue a void for that transaction Example { :ok , transaction } = Transaction . void ( &quot;123&quot; ) transaction . status # &quot;voided&quot;","ref":"Braintree.Transaction.html#void/2","title":"Braintree.Transaction.void/2","type":"function"},{"doc":"","ref":"Braintree.Transaction.html#t:t/0","title":"Braintree.Transaction.t/0","type":"type"},{"doc":"For fetching line items for a given transaction. https://developers.braintreepayments.com/reference/response/transaction-line-item/ruby","ref":"Braintree.TransactionLineItem.html","title":"Braintree.TransactionLineItem","type":"module"},{"doc":"Find transaction line items for the given transaction id. Example { :ok , transaction_line_items } = TransactionLineItem . find ( &quot;123&quot; )","ref":"Braintree.TransactionLineItem.html#find_all/2","title":"Braintree.TransactionLineItem.find_all/2","type":"function"},{"doc":"Converts a list of transaction line item maps into a list of transaction line items. Example transaction_line_items = Braintree.TransactionLineItem.new(%{ &quot;name&quot; =&gt; &quot;item name&quot; , &quot;total_amount&quot; =&gt; &quot;100.00&quot; })","ref":"Braintree.TransactionLineItem.html#new/1","title":"Braintree.TransactionLineItem.new/1","type":"function"},{"doc":"","ref":"Braintree.TransactionLineItem.html#t:t/0","title":"Braintree.TransactionLineItem.t/0","type":"type"},{"doc":"UsBankAccount structs are not created directly, but are built within responses from other endpoints, such as Braintree.Customer .","ref":"Braintree.UsBankAccount.html","title":"Braintree.UsBankAccount","type":"module"},{"doc":"","ref":"Braintree.UsBankAccount.html#new/1","title":"Braintree.UsBankAccount.new/1","type":"function"},{"doc":"","ref":"Braintree.UsBankAccount.html#t:t/0","title":"Braintree.UsBankAccount.t/0","type":"type"},{"doc":"General purpose utility functions.","ref":"Braintree.Util.html","title":"Braintree.Util","type":"module"},{"doc":"Recursively convert a map of string keys into a map with atom keys. Intended to prepare responses for conversion into structs. Note that it converts any string into an atom, whether it existed or not. For unknown maps with unknown keys this is potentially dangerous, but should be fine when used with known Braintree endpoints. Example iex&gt; Braintree.Util . atomize ( %{ &quot;a&quot; =&gt; 1 , &quot;b&quot; =&gt; %{ &quot;c&quot; =&gt; 2 } } ) %{ a : 1 , b : %{ c : 2 } } iex&gt; Braintree.Util . atomize ( %{ a : 1 , b : %{ &quot;c&quot; =&gt; 2 } } ) %{ a : 1 , b : %{ c : 2 } }","ref":"Braintree.Util.html#atomize/1","title":"Braintree.Util.atomize/1","type":"function"},{"doc":"Converts underscored values to hyphenated strings. Examples iex&gt; Braintree.Util . hyphenate ( &quot;brain_tree&quot; ) &quot;brain-tree&quot; iex&gt; Braintree.Util . hyphenate ( :brain_tree ) &quot;brain-tree&quot;","ref":"Braintree.Util.html#hyphenate/1","title":"Braintree.Util.hyphenate/1","type":"function"},{"doc":"Converts hyphenated values to underscore delimited strings. Examples iex&gt; Braintree.Util . underscorize ( &quot;brain-tree&quot; ) &quot;brain_tree&quot; iex&gt; Braintree.Util . underscorize ( :&quot;brain-tree&quot; ) &quot;brain_tree&quot;","ref":"Braintree.Util.html#underscorize/1","title":"Braintree.Util.underscorize/1","type":"function"},{"doc":"This module provides convenience methods for parsing Braintree webhook payloads.","ref":"Braintree.Webhook.html","title":"Braintree.Webhook","type":"module"},{"doc":"Return a map containing the payload and signature from the braintree webhook event.","ref":"Braintree.Webhook.html#parse/3","title":"Braintree.Webhook.parse/3","type":"function"},{"doc":"This module provides convenience methods to help validate Braintree signatures and associated payloads for webhooks.","ref":"Braintree.Webhook.Digest.html","title":"Braintree.Webhook.Digest","type":"module"},{"doc":"Returns the message as a hex-encoded string to validate it matches the signature from the braintree webhook event.","ref":"Braintree.Webhook.Digest.html#hexdigest/2","title":"Braintree.Webhook.Digest.hexdigest/2","type":"function"},{"doc":"A wrapper function that does a secure comparision accounting for timing attacks.","ref":"Braintree.Webhook.Digest.html#secure_compare/2","title":"Braintree.Webhook.Digest.secure_compare/2","type":"function"},{"doc":"This module provides convenience methods to help validate Braintree signatures and associated payloads for webhooks.","ref":"Braintree.Webhook.Validation.html","title":"Braintree.Webhook.Validation","type":"module"},{"doc":"Validate the webhook signature and payload from braintree.","ref":"Braintree.Webhook.Validation.html#validate_signature/3","title":"Braintree.Webhook.Validation.validate_signature/3","type":"function"},{"doc":"XML dumping tailored to encoding params sent by Braintree.","ref":"Braintree.XML.Decoder.html","title":"Braintree.XML.Decoder","type":"module"},{"doc":"Converts an XML document, or fragment, into a map. Type annotation attributes are respected, but all other attributes are ignored. Examples iex&gt; Braintree.XML.Decoder . load ( &quot;&lt;a&gt;&lt;b type=&#39;integer&#39;&gt;1&lt;/b&gt;&lt;c&gt;2&lt;/c&gt;&lt;/a&gt;&quot; ) %{ &quot;a&quot; =&gt; %{ &quot;b&quot; =&gt; 1 , &quot;c&quot; =&gt; &quot;2&quot; } } iex&gt; Braintree.XML.Decoder . load ( &quot;&lt;a&gt;&lt;b type=&#39;string&#39;&gt;Jos&amp;#233;&lt;/b&gt;&lt;/a&gt;&quot; ) %{ &quot;a&quot; =&gt; %{ &quot;b&quot; =&gt; &quot;José&quot; } } iex&gt; Braintree.XML.Decoder . load ( &quot;&lt;a&gt;&lt;b type=&#39;string&#39;&gt;First &amp;amp; Last&lt;/b&gt;&lt;/a&gt;&quot; ) %{ &quot;a&quot; =&gt; %{ &quot;b&quot; =&gt; &quot;First &amp; Last&quot; } } iex&gt; Braintree.XML.Decoder . load ( &quot;&lt;a&gt;&lt;b type=&#39;string&#39;&gt;&amp;quot;air quotes&amp;quot;&lt;/b&gt;&lt;/a&gt;&quot; ) %{ &quot;a&quot; =&gt; %{ &quot;b&quot; =&gt; ~s(&quot;air quotes&quot;) } }","ref":"Braintree.XML.Decoder.html#load/1","title":"Braintree.XML.Decoder.load/1","type":"function"},{"doc":"","ref":"Braintree.XML.Decoder.html#t:xml/0","title":"Braintree.XML.Decoder.xml/0","type":"type"},{"doc":"XML encoding tailored to dumping Braintree compatible params.","ref":"Braintree.XML.Encoder.html","title":"Braintree.XML.Encoder","type":"module"},{"doc":"Converts a map into the equivalent XML representation. Examples iex&gt; Braintree.XML.Encoder . dump ( %{ a : %{ b : 1 , c : 2 } } ) ~s|&lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot; ?&gt; \\n &lt;a&gt; \\n &lt;b&gt;1&lt;/b&gt; \\n &lt;c&gt;2&lt;/c&gt; \\n &lt;/a&gt;| iex&gt; Braintree.XML.Encoder . dump ( %{ a : %{ b : &quot;&lt;tag&gt;&quot; } } ) ~s|&lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot; ?&gt; \\n &lt;a&gt; \\n &lt;b&gt;&amp;lt;tag&amp;gt;&lt;/b&gt; \\n &lt;/a&gt;|","ref":"Braintree.XML.Encoder.html#dump/1","title":"Braintree.XML.Encoder.dump/1","type":"function"},{"doc":"","ref":"Braintree.XML.Encoder.html#t:xml/0","title":"Braintree.XML.Encoder.xml/0","type":"type"},{"doc":"XML entity conversion for known entities.","ref":"Braintree.XML.Entity.html","title":"Braintree.XML.Entity","type":"module"},{"doc":"Replace all escaped HTML entities, except those that would produce invalid XML Examples iex&gt; Braintree.XML.Entity . decode ( &quot;&amp;lt;tag&amp;gt;&quot; ) &quot;&amp;lt;tag&amp;gt;&quot; iex&gt; Braintree.XML.Entity . decode ( &quot;S&amp;#248;ren&quot; ) &quot;Søren&quot; iex&gt; Braintree.XML.Entity . decode ( &quot;Normal&quot; ) &quot;Normal&quot; iex&gt; Braintree.XML.Entity . decode ( &quot;First &amp;amp; Last&quot; ) &quot;First &amp;amp; Last&quot; iex&gt; Braintree.XML.Entity . decode ( &quot;&amp;quot;air quotes&amp;quot;&quot; ) ~s(&quot;air quotes&quot;)","ref":"Braintree.XML.Entity.html#decode/1","title":"Braintree.XML.Entity.decode/1","type":"function"},{"doc":"Encode all illegal XML characters by replacing them with corresponding entities. Examples iex&gt; Braintree.XML.Entity . encode ( &quot;&lt;tag&gt;&quot; ) &quot;&amp;lt;tag&amp;gt;&quot; iex&gt; Braintree.XML.Entity . encode ( &quot;Here &amp; There&quot; ) &quot;Here &amp;amp; There&quot;","ref":"Braintree.XML.Entity.html#encode/1","title":"Braintree.XML.Entity.encode/1","type":"function"},{"doc":"Raised at runtime when a config variable is missing.","ref":"Braintree.ConfigError.html","title":"Braintree.ConfigError","type":"exception"},{"doc":"Build a new ConfigError exception.","ref":"Braintree.ConfigError.html#exception/1","title":"Braintree.ConfigError.exception/1","type":"function"},{"doc":"","ref":"changelog.html","title":"CHANGELOG","type":"extras"},{"doc":"Added [Braintree.Webhook] Allow passing options to webhook parser/validator, similar to other API functions. [Braintree.Plan] Expand plan functionality with delete , improved guard clauses, and better response code formatting. [Braintree.Customer] Support ACH Direct Debit payment methods. Fixed [Braintree.HTTP] Fix error in response type specification. This typespec error wasn't caught given the current dialyzer settings, but could cause issues for clients expecting things like {:error, :not_found} .","ref":"changelog.html#v0-13-0-2022-10-24","title":"CHANGELOG - v0.13.0 2022-10-24","type":"extras"},{"doc":"Fixed Update CA certificate bundle and enable peer verification for all HTTP requests.","ref":"changelog.html#v0-12-1-2021-11-18","title":"CHANGELOG - v0.12.1 2021-11-18","type":"extras"},{"doc":"Changed Bumped the minium Elixir version from 1.7 to 1.9 (it had been a while!) Added [Braintree.Webhook] A new module that provides convenience methods for parsing Braintree webhook payloads. [Braintree] Wrap HTTP calls in telemetry events for instrumentation. All requests are wrapped in a telemetry events, which emits standard span events: [:braintree, :request, :start | :stop | :exception | :error] [Braintree.Customer] Support ApplePay and AndroidPay Fixed Fix atomizing nested maps with mixed keys.","ref":"changelog.html#v0-12-0-2021-09-02","title":"CHANGELOG - v0.12.0 2021-09-02","type":"extras"},{"doc":"[Braintree] Allow configuration of sandbox endpoint for testing [Braintree.CreditCard] Include billing_address with the CreditCard struct [Braintree.Transaction] Add support for android_pay_card and correct field names to match android_pay_card and apple_pay [Braintree.Transaction] Rename customer_details to customer to correctly reflect API results. [Braintree.Search] Fix perform so that it correctly handles transaction results [Braintree.TestTransaction] Make TestTransaction available in all environments.","ref":"changelog.html#v0-11-0-2020-05-11","title":"CHANGELOG - v0.11.0 2020-05-11","type":"extras"},{"doc":"Enhancements [Braintree.HTTP] Support both access_token and public/private keys usage in configuration","ref":"changelog.html#v0-10-0-2019-03-26","title":"CHANGELOG - v0.10.0 2019-03-26","type":"extras"},{"doc":"Enhancements [Braintree] Use system tuples as the default for application env [Braintree] Add dialyxer and fix all typespecs. Typespecs are now validated during CI builds [Braintree.HTTP] Expose 429 Too Many Requests error with an integer to status mapping [Braintree.TestTransaction] The module is now available in all environments, not just test [Braintree.Address] Support added for address features [Braintree.MerchantAccounts] Support added for merchant account features [Braintree.Search] Support for searching customers, credit cards and subscriptions [Braintree.XML] Support collections when decoding XML responses Changes [Braintree] Elixir 1.5 is now the minimum supported version [Braintree.Transaction] Replace :billing_details with the correctly named :billing Bug Fixes [Braintree.HTTP] Use Keyword.get_lazy to avoid exceptions when config keys used for requests aren't set. [Braintree.HTTP] Add explicit handling for unprocessable_entity errors [Braintree.HTTP] Always coerce the environment to an atom","ref":"changelog.html#v0-9-0-2018-06-18","title":"CHANGELOG - v0.9.0 2018-06-18","type":"extras"},{"doc":"Enhancements [Braintree.ErrorResponse] Include full transaction details in the ErrorResponse struct. This displays the underlying reason a request failed, helping developers diagnose failing requests. [Braintree.HTTP] Ability to optionally pass environment and API keys as options to all functions doing API calls. The default behaviour of reading from the global config is kept if those keys are not passed as arguments. Submitted by @manukall and @nicolasblanco Changes [Braintree.Construction] Use new/1 to build structs, rather than the unusual construct/1 function. Bug Fixes [Braintree.HTTP] Catch and return 400 Bad Request error tuples, rather than generating a case clause error.","ref":"changelog.html#v0-8-0-2017-08-24","title":"CHANGELOG - v0.8.0 2017-08-24","type":"extras"},{"doc":"Enhancements [Braintree.ClientToken] Set the default client token version to 2 . [Braintree.Discount] Add support for discounts [Braintree.AddOn] Add support for add-ons [Braintree.SettlementBatchSummary] Add support for settlement reports [Braintree.Subscription] Support updating with update/2 [Braintree.Subscription] Convert add-on and transaction lists to structs Changes [Braintree.XML] Strictly accept maps for generation, not keyword lists. Bug Fixes [Braintree.XML] Correctly handle decoding entities such as &amp;amp; , &amp;gt; and &amp;lt; . [Braintree.XML] Fix encoding XML array values [Braintree.XML] Add encoding of binaries","ref":"changelog.html#v0-7-0-2016-09-20","title":"CHANGELOG - v0.7.0 2016-09-20","type":"extras"},{"doc":"Enhancements [Braintree.HTTP] Remove dependency on HTTPoison! Instead Hackney is used directly. [Braintree.HTTP] Configuration options can be provided for Hackney via http_options . [Braintree] Support {:system, VAR} for configs [Braintree.XML] Support for parsing top level arrays. Some endpoints, notably plans , may return an array rather than an object [Braintree.Plan] Added module and all/0 for retrieving billing plans [Braintree.Customer] Enhanced with find/1 [Braintree.Subscription] Enhanced with cancel/1 and retry_charge/1 Bug Fixes [Braintree.XML.Entity] XML entities are automatically encoded and decoded. This prevents errors when values contain quotes, ampersands, or other characters that must be escaped [Braintree.Customer] Return a tagged error tuple for delete/1 [Braintree.Transaction] Use the correct paypal field for Transaction responses","ref":"changelog.html#v0-6-0-2016-08-10","title":"CHANGELOG - v0.6.0 2016-08-10","type":"extras"},{"doc":"Added: Paypal endpoints for use with the vault flow [TylerCain] Added: Construct Paypal accounts from customer responses Added: Support submit_for_settlement/2 to Transaction Added: Typespec for the Transaction struct Fixed: Typespec for the CreditCard struct Fixed: Include xmerl in the list of applications to ensure that it is packaged with exrm releases.","ref":"changelog.html#v0-5-0-2016-06-13","title":"CHANGELOG - v0.5.0 2016-06-13","type":"extras"},{"doc":"Added: Available only during testing, TestTransaction , which can be used to transition transactions to different states. Added: Add find , void , and refund on Transaction . [Tyler Cain] Added: Add support for PaymentMethod , PaymentMethodNonce . [Tyler Cain] Added: Basic support for subscription management, starting with create . [Ryan Bigg]","ref":"changelog.html#v0-4-0-2016-04-20","title":"CHANGELOG - v0.4.0 2016-04-20","type":"extras"},{"doc":"Fixed: Log unprocessable responses rather than inspecting them to STDOUT. Fixed: Convert 404 and 401 responses to error tuples, they are common problems with misconfiguration.","ref":"changelog.html#v0-3-2-2016-02-26","title":"CHANGELOG - v0.3.2 2016-02-26","type":"extras"},{"doc":"Fixed: Lookup the certfile path at runtime rather than compile time. This fixes potential build errors when pre-building releases or packaging on platforms like Heroku.","ref":"changelog.html#v0-3-1-2016-02-18","title":"CHANGELOG - v0.3.1 2016-02-18","type":"extras"},{"doc":"Fixed: Raise helpful errors when missing required config Added: Client token module for generating new client tokens [Taylor Briggs]","ref":"changelog.html#v0-3-0-2016-02-17","title":"CHANGELOG - v0.3.0 2016-02-17","type":"extras"},{"doc":"Added: Support for updating and deleting customers. Added: A Nonces module for help testing transactions. Changed: Include testing support Braintree.Testing.CreditCardNumbers as well as Braintree.Testing.Nonces in lib/testing , making it available in packaged releases. Fixed: Trying to call XML.load on empty strings returns an empty map. Removed: The __using__ macro has been removed from HTTP because the naming conflicted with delete actions. An equivalent macro will be introduced in the future.","ref":"changelog.html#v0-2-0-2016-02-05","title":"CHANGELOG - v0.2.0 2016-02-05","type":"extras"},{"doc":"Initial release with support for Customer.create and Transaction.sale .","ref":"changelog.html#v0-1-0-2016-02-03","title":"CHANGELOG - v0.1.0 2016-02-03","type":"extras"},{"doc":"A native Braintree client library for Elixir.","ref":"readme.html","title":"Braintree","type":"extras"},{"doc":"Add braintree to your list of dependencies in mix.exs : def deps do [ { :braintree , &quot;~&gt; 0.13&quot; } ] end Once that is configured you are all set. Braintree is a library, not an application, but it does rely on hackney , which must be started. For Elixir versions &lt; 1.4 you'll need to include it in the list of applications: def application do [ applications : [ :braintree ] ] end Within your application you will need to configure the merchant id and authorization keys. You do not want to put this information in your config.exs file! Either put it in a {prod,dev,test}.secret.exs file which is sourced by config.exs , or read the values in from the environment: config :braintree , environment : :sandbox , master_merchant_id : { :system , &quot;BRAINTREE_MASTER_MERCHANT_ID&quot; } , merchant_id : { :system , &quot;BRAINTREE_MERCHANT_ID&quot; } , public_key : { :system , &quot;BRAINTREE_PUBLIC_KEY&quot; } , private_key : { :system , &quot;BRAINTREE_PRIVATE_KEY&quot; } Furthermore, the environment defaults to :sandbox , so you'll want to configure it with :production in prod.exs . You may optionally pass directly those configuration keys to all functions performing an API call. In that case, those keys will be used to perform the call. You can optionally configure Hackney options with: config :braintree , http_options : [ timeout : 30_000 , # default, in milliseconds recv_timeout : 5000 # default, in milliseconds ]","ref":"readme.html#installation","title":"Braintree - Installation","type":"extras"},{"doc":"The online documentation for Ruby/Java/Python etc. will give you a general idea of the modules and available functionality. Where possible the namespacing has been preserved. The CRUD functions for each action module break down like this: alias Braintree.Customer alias Braintree.ErrorResponse , as : Error case Customer . create ( %{ company : &quot;Whale Corp&quot; } ) do { :ok , % Customer { } = customer } -&gt; do_stuff_with_customer ( customer ) { :error , % Error { } = error } -&gt; do_stuff_with_error ( error ) end Searching Search params are constructed with a fairly complex structure of maps. There isn't a DSL provided, so queries must be constructed by hand. For example, to search for a customer: search_params = %{ first_name : %{ is : &quot;Jenna&quot; } , last_name : %{ starts_with : &quot;Smith&quot; , contains : &quot;ith&quot; , is_not : &quot;Smithsonian&quot; } , email : %{ ends_with : &quot;gmail.com&quot; } } { :ok , customers } = Braintree.Customer . search ( search_params ) Or, to search for pending credit card verifications within a particular dollar amount: search_params = %{ amount : %{ min : &quot;10.0&quot; , max : &quot;15.0&quot; } , status : [ &quot;approved&quot; , &quot;pending&quot; ] } { :ok , verifications } = Braintree.CreditCardVerification . search ( search_params ) Telemetry If the telemetry application is running, the library will emit telemetry events. Immediately before the HTTP request is fired, a start event will be fired with the following shape: event name : [ :braintree , :request , :start ] measurements : %{ system_time : System . system_time ( ) } meta data : %{ method : method , path : path } Once the HTTP call completes, a stop event will be fired with the following shape: event name : [ :braintree , :request , :stop ] measurements : %{ duration : duration } meta data : %{ method : method , path : path , http_status : status } If Hackney returns an error, an error event will be fired with the following shape: event name : [ :braintree , :request , :error ] measurements : %{ duration : duration } meta data : %{ method : method , path : path , error : error_reason } If an exception is raised during the Hackney call, an exception event will be fired with the following shape: event name : [ :braintree , :request , :exception ] measurements : %{ duration : duration } meta data : %{ method : method , path : path , kind : error_type , reason : error_message , stacktrace : stacktrace }","ref":"readme.html#usage","title":"Braintree - Usage","type":"extras"},{"doc":"You'll need a Braintree sandbox account to run the integration tests. Also, be sure that your account has Duplicate Transaction Checking disabled. Merchant Account Features In order to test the merchant account features, your sandbox account needs to have a master merchant account and it needs to be added to your environment variables (only needed in test). Your environment needs to have the following: Add-ons with ids: &quot;bronze&quot;, &quot;silver&quot; and &quot;gold&quot; Plans with ids: &quot;starter&quot;, &quot;business&quot; &quot;business&quot; plan needs to include the following add-ons: &quot;bronze&quot; and &quot;silver&quot; PayPal Account Testing PayPal testing uses the mocked API flow, which requires linking a sandbox PayPal account. You can accomplish that by following the directions for linked paypal testing . Testing Using Only localhost You can optionally configure the sandbox endpoint url to point towards a local url and port for testing which does not need to call out to the Braintree sandbox API. For example, in your config.exs config :braintree , :sandbox_endpoint , &quot;localhost:4001&quot; In conjuction with a libary such as Bypass you can use this config to define test-specific returns from Braintree calls without hitting the Braintree sandbox API.","ref":"readme.html#testing","title":"Braintree - Testing","type":"extras"},{"doc":"MIT License, see LICENSE.txt for details.","ref":"readme.html#license","title":"Braintree - License","type":"extras"}]